#!/bin/bash
###############################################################
################## v2/v3 scanner ##############################
# a little bash script to scan the darkweb for tor addresses
# adjust the proxy variables in /etc/lynx/lynx.cfg if needed
# than just call the script from a subdir, and let run
# you will need a file called "links.txt" containing onion
# links to start the script of (there are some popular
# addresses preloaded).
# the script runs in an endless loop until there are no more
# links to be followed or until the maximum number of runs is
# achieved. you can stop anytime with CTRL+C
# without loosing anything but the currently
# running request. Another start of the script, and it will
# pickup where it was interrupted. all of this is
# EXPERIMENTAL CODE, USE AT OWN RISK
# And use it responsibly, please. Don't dos.
# version 0.18
###############################################################
max_runs=100000 # max number of links to follow
max_links=2 # max number of links to follow per host, except the addresses in seeds.txt
counter=0 # the counter variable we use to follow the number of links
up=0 # the number of hosts found to be up (= answering with 200 to a HEAD request)
down=0 # the number of hosts found to be down
touch ./working_files/up.txt
touch ./working_files/down.txt
touch ./working_files/visited_links.txt # the list of all links we have tried
touch ./working_files/blocklist.txt # a list of addresses not to follow (empty by default)
touch ./working_files/max_visit.txt # the file to track which hosts have been visited max_times
touch ./working_files/seeds.txt # list of addresses to which max_times does not apply
touch ./working_files/all_links.txt # unsorted list of all onion links found, with duplicates
touch ./results/results.txt # addresses and stats for hosts found to be up
touch ./results/heartbeat.txt # file with status logs
touch ./working_files/bias.txt
echo "started new go at" >> ./results/heartbeat.txt
date >> ./results/heartbeat.txt
while true
do
	counter=$(("$counter"+1))
	up=$(wc -l working_files/up.txt | cut -f1 -d' ')
	down=$(wc -l working_files/down.txt | cut -f1 -d' ')
	sort -u working_files/links.txt | grep -E 'http:\/\/[[:alnum:]]{16,76}\.onion.*' | sort > working_files/links_new.txt && mv working_files/links_new.txt working_files/links.txt
	sort -u working_files/links.txt | grep -o -E 'http:\/\/[[:alnum:]]{16,76}\.onion' | sort -u | sort > working_files/hosts.txt
	sort -u working_files/visited_links.txt | sort > working_files/visited_links_new.txt && mv working_files/visited_links_new.txt working_files/visited_links.txt
	sort -u working_files/max_visit.txt | sort > working_files/max_visit_new.txt && mv working_files/max_visit_new.txt working_files/max_visit.txt
	sort -u working_files/down.txt | sort > working_files/down_new.txt && mv working_files/down_new.txt working_files/down.txt
	sort -u working_files/up.txt | sort > working_files/up_new.txt && mv working_files/up_new.txt working_files/up.txt
	sort -u working_files/blocklist.txt | sort > working_files/blocklist_new.txt && mv working_files/blocklist_new.txt working_files/blocklist.txt
	comm -23 working_files/links.txt working_files/visited_links.txt > working_files/links_new.txt && mv working_files/links_new.txt working_files/links.txt
	comm -23 working_files/hosts.txt working_files/blocklist.txt > working_files/hosts_new.txt
	comm -23 working_files/hosts_new.txt working_files/down.txt > working_files/hosts.txt
	comm -23 working_files/hosts.txt working_files/max_visit.txt > working_files/hosts_new.txt && mv working_files/hosts_new.txt working_files/hosts.txt
	grep -Ff working_files/hosts.txt working_files/up.txt > working_files/bias.txt
	max_visited=$(wc -l working_files/max_visit.txt | cut -f1 -d' ')
	visited_link_count=$(wc -l working_files/visited_links.txt | cut -f1 -d ' ')
	link_count=$(wc -l working_files/links.txt | cut -f1 -d ' ')
	service_count=$(wc -l working_files/hosts.txt | cut -f1 -d' ')
	if [ -z $service_count ]; then
		echo "no hosts left, we are done\n\r"
		exit 0
	fi
	visited_service_count=$(grep -E -o 'http:\/\/[[:alnum:]]{16,76}\.onion' working_files/visited_links.txt | sort -u | wc -l)
	echo -e "We have tried to visit $visited_link_count links on $visited_service_count hosts, found $up hosts up, and $down hosts down. We still have $link_count unique links on $service_count hosts, $max_visited hosts have been visited $max_links times or more \n\r"
	service=$(cat "working_files/hosts.txt" "working_files/bias.txt" | grep -E -o 'http:\/\/[[:alnum:]]{56,76}\.onion' | sort -R | head -n 1)
	if [ -z "$service" ]; then
		service=$(cat "working_files/hosts.txt" "working_files/bias.txt" | sort -R | head -n 1)
		if [ -z "$service" ]; then
			echo "no hosts left, we are done\n\r"
			exit 0
		fi
	fi
	service_dir=$(echo "$service" | cut -c8- | rev | cut -c7- | rev)
	echo -e "checking if $service is up or not\n\r"
	if lynx -head -dump "$service" 2>&1 | grep -w "200" ; then
		if [ ! -d "./hosts/$service_dir" ]; then
			mkdir "hosts/$service_dir"
			touch "hosts/$service_dir/links.txt" 
		fi
    		echo "$service is up"
		echo "$service" >> working_files/up.txt
		link=$(grep "^$service" working_files/links.txt | sort -R | head -n 1)
		if [ -z "$link" ]; then
			echo "no specific links for $service, using onion address"
			link="$service"
		fi
		echo -e "trying to get $link in run number $counter,\n\r"
		echo "$link" >> working_files/visited_links.txt
		lynx -dump -listonly "$link" | grep -E 'http:\/\/[[:alnum:]]{16,76}\.onion.*' | grep -E -i -v '.*\.jpg$|.*\.gif$|.*\.png$|.*\.pdf$|.*\.mp3$|.*\.m3u$|.*\.avi$|.*\.jpeg$|.*\.bmp$|.*\.mkv$|.*\.deb$|.*\.opus$' | cut -f2- -d '.' | cut -c2- >> "hosts/$service_dir/links.txt"
		echo "$link" >> "hosts/$service_dir/visited_links.txt"
		link_count=$(wc -l "hosts/$service_dir/visited_links.txt" | cut -f1 -d' ')
		seed=$(grep "$service" working_files/seeds.txt | wc -l)
		if [ "$link_count" -ge $max_links ] && [ $seed -eq 0 ]; then
			echo "$service" >> working_files/max_visit.txt
		fi
		echo "$(<hosts/$service_dir/links.txt )" >> ./working_files/links.txt
		echo "$(<hosts/$service_dir/links.txt )" >> ./working_files/all_links.txt
		to_internal_links=$(sort -u "hosts/$service_dir/links.txt" | grep "$service" | wc -l)
		to_internal_links_all=$(grep "$service" "hosts/$service_dir/links.txt" | wc -l)
		to_external_links=$(sort -u "hosts/$service_dir/links.txt" | grep -v "$service" | wc -l)
		from_external_links_total=$(grep "$service" "working_files/all_links.txt" | wc -l)
		from_external_links=$(($from_external_links_total - $to_internal_links_all))
		adult_score=$(grep -Ff "keywords/adult.txt" "hosts/$service_dir/links.txt" | wc -l)
		market_score=$(grep -Ff "keywords/market.txt" "hosts/$service_dir/links.txt" | wc -l)
		guns_score=$(grep -Ff "keywords/guns.txt" "hosts/$service_dir/links.txt" | wc -l)
		drugs_score=$(grep -Ff "keywords/drugs.txt" "hosts/$service_dir/links.txt" | wc -l)
		cp_score=$(grep -Ff "keywords/cp.txt" "hosts/$service_dir/links.txt" | wc -l)
		altright_score=$(grep -Ff "keywords/altright.txt" "hosts/$service_dir/links.txt" | wc -l)
		echo "$service|$to_internal_links|$to_external_links|$from_external_links|$adult_score|$market_score|$guns_score|$drugs_score|$cp_score|$altright_score"
		echo "$service|$to_internal_links|$to_external_links|$from_external_links|$adult_score|$market_score|$guns_score|$drugs_score|$cp_score|$altright_score" >> results/results.txt
	else
		echo "$service is down"
		echo "$service" >> working_files/down.txt
	fi
	date_string=$(date)
	if ((counter%5 == 0)); then
		echo -e "$date_string, we have tried to visit $visited_link_count links on $visited_service_count hosts, found $up hosts up, and $down hosts down. We still have $link_count unique links on $service_count hosts" >> "results/heartbeat.txt"
	fi
	if [ "$counter" -ge $max_runs ]; then
		echo "ran $count times, reached the maximum defined number of runs, exiting now"
		echo -e "$date_string, we have tried to visit $visited_link_count links on $visited_service_count hosts, found $up hosts up, and $down hosts down. We still have $link_count unique links on $service_count hosts" >> "results/heartbeat.txt"
		echo -e "$date_string, we have reached the maximum number of runs, exiting" >> "results/heartbeat.txt"
		exit 0
	fi
done
